diff --git a/rsvg-styles.c b/rsvg-styles.c
index 0e6095c..6836894 100644
--- a/rsvg-styles.c
+++ b/rsvg-styles.c
@@ -363,350 +465,353 @@ rsvg_state_inherit (RsvgState * dst, const RsvgState * src)
 void
 rsvg_state_finalize (RsvgState * state)
 {
+    g_free (state->filter);
+    g_free (state->mask);
+    g_free (state->clip_path);
     g_free (state->font_family);
     g_free (state->lang);
+    g_free (state->startMarker);
+    g_free (state->middleMarker);
+    g_free (state->endMarker);
     rsvg_paint_server_unref (state->fill);
     rsvg_paint_server_unref (state->stroke);
 
     if (state->dash.n_dash != 0)
         g_free (state->dash.dash);
+
+    if (state->styles) {
+        g_hash_table_unref (state->styles);
+        state->styles = NULL;
+    }
 }
 
 /* Parse a CSS2 style argument, setting the SVG context attributes. */
 static void
-rsvg_parse_style_arg (RsvgHandle * ctx, RsvgState * state, const char *str)
+rsvg_parse_style_pair (RsvgHandle * ctx,
+                       RsvgState * state,
+                       const gchar * name,
+                       const gchar * value,
+                       gboolean important)
 {
-    int arg_off;
-
-    arg_off = rsvg_css_param_arg_offset (str);
-
-    if (rsvg_css_param_match (str, "color"))
-        state->current_color = rsvg_css_parse_color (str + arg_off, &state->has_current_color);
-    else if (rsvg_css_param_match (str, "opacity"))
-        state->opacity = rsvg_css_parse_opacity (str + arg_off);
-    else if (rsvg_css_param_match (str, "flood-color"))
-        state->flood_color = rsvg_css_parse_color (str + arg_off, &state->has_flood_color);
-    else if (rsvg_css_param_match (str, "flood-opacity")) {
-        state->flood_opacity = rsvg_css_parse_opacity (str + arg_off);
+    StyleValueData *data;
+
+    data = g_hash_table_lookup (state->styles, name);
+    if (data && data->important && !important)
+        return;
+
+    if (name == NULL || value == NULL)
+        return;
+
+    g_hash_table_insert (state->styles,
+                         (gpointer) g_strdup (name),
+                         (gpointer) style_value_data_new (value, important));
+
+    if (g_str_equal (name, "color"))
+        state->current_color = rsvg_css_parse_color (value, &state->has_current_color);
+    else if (g_str_equal (name, "opacity"))
+        state->opacity = rsvg_css_parse_opacity (value);
+    else if (g_str_equal (name, "flood-color"))
+        state->flood_color = rsvg_css_parse_color (value, &state->has_flood_color);
+    else if (g_str_equal (name, "flood-opacity")) {
+        state->flood_opacity = rsvg_css_parse_opacity (value);
         state->has_flood_opacity = TRUE;
-    } else if (rsvg_css_param_match (str, "filter"))
-        state->filter = rsvg_filter_parse (ctx->priv->defs, str + arg_off);
-    else if (rsvg_css_param_match (str, "a:adobe-blending-mode")) {
-        if (!strcmp (str + arg_off, "normal"))
-            state->adobe_blend = 0;
-        else if (!strcmp (str + arg_off, "multiply"))
-            state->adobe_blend = 1;
-        else if (!strcmp (str + arg_off, "screen"))
-            state->adobe_blend = 2;
-        else if (!strcmp (str + arg_off, "darken"))
-            state->adobe_blend = 3;
-        else if (!strcmp (str + arg_off, "lighten"))
-            state->adobe_blend = 4;
-        else if (!strcmp (str + arg_off, "softlight"))
-            state->adobe_blend = 5;
-        else if (!strcmp (str + arg_off, "hardlight"))
-            state->adobe_blend = 6;
-        else if (!strcmp (str + arg_off, "colordodge"))
-            state->adobe_blend = 7;
-        else if (!strcmp (str + arg_off, "colorburn"))
-            state->adobe_blend = 8;
-        else if (!strcmp (str + arg_off, "overlay"))
-            state->adobe_blend = 9;
-        else if (!strcmp (str + arg_off, "exclusion"))
-            state->adobe_blend = 10;
-        else if (!strcmp (str + arg_off, "difference"))
-            state->adobe_blend = 11;
-        else
-            state->adobe_blend = 0;
-    } else if (rsvg_css_param_match (str, "mask"))
-        state->mask = rsvg_mask_parse (ctx->priv->defs, str + arg_off);
-    else if (rsvg_css_param_match (str, "clip-path")) {
-        state->clip_path_ref = rsvg_clip_path_parse (ctx->priv->defs, str + arg_off);
-    } else if (rsvg_css_param_match (str, "overflow")) {
-        if (strcmp (str + arg_off, "inherit")) {
-            state->overflow = rsvg_css_parse_overflow (str + arg_off, &state->has_overflow);
+    } else if (g_str_equal (name, "filter")) {
+        g_free (state->filter);
+        state->filter = rsvg_get_url_string (value);
+    } else if (g_str_equal (name, "mask")) {
+        g_free (state->mask);
+        state->mask = rsvg_get_url_string (value);
+    } else if (g_str_equal (name, "baseline-shift")) {
+        /* These values come from Inkscape's SP_CSS_BASELINE_SHIFT_(SUB/SUPER/BASELINE);
+         * see sp_style_merge_baseline_shift_from_parent()
+         */
+        if (g_str_equal (value, "sub")) {
+           state->has_baseline_shift = TRUE;
+           state->baseline_shift = -0.2;
+        } else if (g_str_equal (value, "super")) {
+           state->has_baseline_shift = TRUE;
+           state->baseline_shift = 0.4;
+        } else if (g_str_equal (value, "baseline")) {
+           state->has_baseline_shift = TRUE;
+           state->baseline_shift = 0.;
+        } else {
+          g_warning ("value \'%s\' for attribute \'baseline-shift\' is not supported; only 'sub', 'super', and 'baseline' are supported\n", value);
+        }
+    } else if (g_str_equal (name, "clip-path")) {
+        g_free (state->clip_path);
+        state->clip_path = rsvg_get_url_string (value);
+    } else if (g_str_equal (name, "overflow")) {
+        if (!g_str_equal (value, "inherit")) {
+            state->overflow = rsvg_css_parse_overflow (value, &state->has_overflow);
         }
-    } else if (rsvg_css_param_match (str, "enable-background")) {
-        if (!strcmp (str + arg_off, "new"))
+    } else if (g_str_equal (name, "enable-background")) {
+        if (g_str_equal (value, "new"))
             state->enable_background = RSVG_ENABLE_BACKGROUND_NEW;
         else
             state->enable_background = RSVG_ENABLE_BACKGROUND_ACCUMULATE;
-    } else if (rsvg_css_param_match (str, "comp-op")) {
-        if (!strcmp (str + arg_off, "clear"))
-            state->comp_op = RSVG_COMP_OP_CLEAR;
-        else if (!strcmp (str + arg_off, "src"))
-            state->comp_op = RSVG_COMP_OP_SRC;
-        else if (!strcmp (str + arg_off, "dst"))
-            state->comp_op = RSVG_COMP_OP_DST;
-        else if (!strcmp (str + arg_off, "src-over"))
-            state->comp_op = RSVG_COMP_OP_SRC_OVER;
-        else if (!strcmp (str + arg_off, "dst-over"))
-            state->comp_op = RSVG_COMP_OP_DST_OVER;
-        else if (!strcmp (str + arg_off, "src-in"))
-            state->comp_op = RSVG_COMP_OP_SRC_IN;
-        else if (!strcmp (str + arg_off, "dst-in"))
-            state->comp_op = RSVG_COMP_OP_DST_IN;
-        else if (!strcmp (str + arg_off, "src-out"))
-            state->comp_op = RSVG_COMP_OP_SRC_OUT;
-        else if (!strcmp (str + arg_off, "dst-out"))
-            state->comp_op = RSVG_COMP_OP_DST_OUT;
-        else if (!strcmp (str + arg_off, "src-atop"))
-            state->comp_op = RSVG_COMP_OP_SRC_ATOP;
-        else if (!strcmp (str + arg_off, "dst-atop"))
-            state->comp_op = RSVG_COMP_OP_DST_ATOP;
-        else if (!strcmp (str + arg_off, "xor"))
-            state->comp_op = RSVG_COMP_OP_XOR;
-        else if (!strcmp (str + arg_off, "plus"))
-            state->comp_op = RSVG_COMP_OP_PLUS;
-        else if (!strcmp (str + arg_off, "multiply"))
-            state->comp_op = RSVG_COMP_OP_MULTIPLY;
-        else if (!strcmp (str + arg_off, "screen"))
-            state->comp_op = RSVG_COMP_OP_SCREEN;
-        else if (!strcmp (str + arg_off, "overlay"))
-            state->comp_op = RSVG_COMP_OP_OVERLAY;
-        else if (!strcmp (str + arg_off, "darken"))
-            state->comp_op = RSVG_COMP_OP_DARKEN;
-        else if (!strcmp (str + arg_off, "lighten"))
-            state->comp_op = RSVG_COMP_OP_LIGHTEN;
-        else if (!strcmp (str + arg_off, "color-dodge"))
-            state->comp_op = RSVG_COMP_OP_COLOR_DODGE;
-        else if (!strcmp (str + arg_off, "color-burn"))
-            state->comp_op = RSVG_COMP_OP_COLOR_BURN;
-        else if (!strcmp (str + arg_off, "hard-light"))
-            state->comp_op = RSVG_COMP_OP_HARD_LIGHT;
-        else if (!strcmp (str + arg_off, "soft-light"))
-            state->comp_op = RSVG_COMP_OP_SOFT_LIGHT;
-        else if (!strcmp (str + arg_off, "difference"))
-            state->comp_op = RSVG_COMP_OP_DIFFERENCE;
-        else if (!strcmp (str + arg_off, "exclusion"))
-            state->comp_op = RSVG_COMP_OP_EXCLUSION;
+    } else if (g_str_equal (name, "comp-op")) {
+        if (g_str_equal (value, "clear"))
+            state->comp_op = CAIRO_OPERATOR_CLEAR;
+        else if (g_str_equal (value, "src"))
+            state->comp_op = CAIRO_OPERATOR_SOURCE;
+        else if (g_str_equal (value, "dst"))
+            state->comp_op = CAIRO_OPERATOR_DEST;
+        else if (g_str_equal (value, "src-over"))
+            state->comp_op = CAIRO_OPERATOR_OVER;
+        else if (g_str_equal (value, "dst-over"))
+            state->comp_op = CAIRO_OPERATOR_DEST_OVER;
+        else if (g_str_equal (value, "src-in"))
+            state->comp_op = CAIRO_OPERATOR_IN;
+        else if (g_str_equal (value, "dst-in"))
+            state->comp_op = CAIRO_OPERATOR_DEST_IN;
+        else if (g_str_equal (value, "src-out"))
+            state->comp_op = CAIRO_OPERATOR_OUT;
+        else if (g_str_equal (value, "dst-out"))
+            state->comp_op = CAIRO_OPERATOR_DEST_OUT;
+        else if (g_str_equal (value, "src-atop"))
+            state->comp_op = CAIRO_OPERATOR_ATOP;
+        else if (g_str_equal (value, "dst-atop"))
+            state->comp_op = CAIRO_OPERATOR_DEST_ATOP;
+        else if (g_str_equal (value, "xor"))
+            state->comp_op = CAIRO_OPERATOR_XOR;
+        else if (g_str_equal (value, "plus"))
+            state->comp_op = CAIRO_OPERATOR_ADD;
         else
-            state->comp_op = RSVG_COMP_OP_SRC_OVER;
-    } else if (rsvg_css_param_match (str, "display")) {
+            state->comp_op = CAIRO_OPERATOR_OVER;
+    } else if (g_str_equal (name, "display")) {
         state->has_visible = TRUE;
-        if (!strcmp (str + arg_off, "none"))
+        if (g_str_equal (value, "none"))
             state->visible = FALSE;
-        else if (strcmp (str + arg_off, "inherit") != 0)
+        else if (!g_str_equal (value, "inherit") != 0)
             state->visible = TRUE;
         else
             state->has_visible = FALSE;
-	} else if (rsvg_css_param_match (str, "xml:space")) {
+	} else if (g_str_equal (name, "xml:space")) {
         state->has_space_preserve = TRUE;
-        if (!strcmp (str + arg_off, "default"))
+        if (g_str_equal (value, "default"))
             state->space_preserve = FALSE;
-        else if (strcmp (str + arg_off, "preserve") == 0)
+        else if (!g_str_equal (value, "preserve") == 0)
             state->space_preserve = TRUE;
         else
             state->space_preserve = FALSE;
-    } else if (rsvg_css_param_match (str, "visibility")) {
+    } else if (g_str_equal (name, "visibility")) {
         state->has_visible = TRUE;
-        if (!strcmp (str + arg_off, "visible"))
+        if (g_str_equal (value, "visible"))
             state->visible = TRUE;
-        else if (strcmp (str + arg_off, "inherit") != 0)
+        else if (!g_str_equal (value, "inherit") != 0)
             state->visible = FALSE;     /* collapse or hidden */
         else
             state->has_visible = FALSE;
-    } else if (rsvg_css_param_match (str, "fill")) {
+    } else if (g_str_equal (name, "fill")) {
         RsvgPaintServer *fill = state->fill;
         state->fill =
-            rsvg_paint_server_parse (&state->has_fill_server, ctx->priv->defs, str + arg_off, 0);
+            rsvg_paint_server_parse (&state->has_fill_server, value);
         rsvg_paint_server_unref (fill);
-    } else if (rsvg_css_param_match (str, "fill-opacity")) {
-        state->fill_opacity = rsvg_css_parse_opacity (str + arg_off);
+    } else if (g_str_equal (name, "fill-opacity")) {
+        state->fill_opacity = rsvg_css_parse_opacity (value);
         state->has_fill_opacity = TRUE;
-    } else if (rsvg_css_param_match (str, "fill-rule")) {
+    } else if (g_str_equal (name, "fill-rule")) {
         state->has_fill_rule = TRUE;
-        if (!strcmp (str + arg_off, "nonzero"))
-            state->fill_rule = FILL_RULE_NONZERO;
-        else if (!strcmp (str + arg_off, "evenodd"))
-            state->fill_rule = FILL_RULE_EVENODD;
+        if (g_str_equal (value, "nonzero"))
+            state->fill_rule = CAIRO_FILL_RULE_WINDING;
+        else if (g_str_equal (value, "evenodd"))
+            state->fill_rule = CAIRO_FILL_RULE_EVEN_ODD;
         else
             state->has_fill_rule = FALSE;
-    } else if (rsvg_css_param_match (str, "clip-rule")) {
+    } else if (g_str_equal (name, "clip-rule")) {
         state->has_clip_rule = TRUE;
-        if (!strcmp (str + arg_off, "nonzero"))
-            state->clip_rule = FILL_RULE_NONZERO;
-        else if (!strcmp (str + arg_off, "evenodd"))
-            state->clip_rule = FILL_RULE_EVENODD;
+        if (g_str_equal (value, "nonzero"))
+            state->clip_rule = CAIRO_FILL_RULE_WINDING;
+        else if (g_str_equal (value, "evenodd"))
+            state->clip_rule = CAIRO_FILL_RULE_EVEN_ODD;
         else
             state->has_clip_rule = FALSE;
-    } else if (rsvg_css_param_match (str, "stroke")) {
+    } else if (g_str_equal (name, "stroke")) {
         RsvgPaintServer *stroke = state->stroke;
 
         state->stroke =
-            rsvg_paint_server_parse (&state->has_stroke_server, ctx->priv->defs, str + arg_off, 0);
+            rsvg_paint_server_parse (&state->has_stroke_server, value);
 
         rsvg_paint_server_unref (stroke);
-    } else if (rsvg_css_param_match (str, "stroke-width")) {
-        state->stroke_width = _rsvg_css_parse_length (str + arg_off);
+    } else if (g_str_equal (name, "stroke-width")) {
+        state->stroke_width = _rsvg_css_parse_length (value);
         state->has_stroke_width = TRUE;
-    } else if (rsvg_css_param_match (str, "stroke-linecap")) {
+    } else if (g_str_equal (name, "stroke-linecap")) {
         state->has_cap = TRUE;
-        if (!strcmp (str + arg_off, "butt"))
-            state->cap = RSVG_PATH_STROKE_CAP_BUTT;
-        else if (!strcmp (str + arg_off, "round"))
-            state->cap = RSVG_PATH_STROKE_CAP_ROUND;
-        else if (!strcmp (str + arg_off, "square"))
-            state->cap = RSVG_PATH_STROKE_CAP_SQUARE;
+        if (g_str_equal (value, "butt"))
+            state->cap = CAIRO_LINE_CAP_BUTT;
+        else if (g_str_equal (value, "round"))
+            state->cap = CAIRO_LINE_CAP_ROUND;
+        else if (g_str_equal (value, "square"))
+            state->cap = CAIRO_LINE_CAP_SQUARE;
         else
-            g_warning (_("unknown line cap style %s\n"), str + arg_off);
-    } else if (rsvg_css_param_match (str, "stroke-opacity")) {
-        state->stroke_opacity = rsvg_css_parse_opacity (str + arg_off);
+            g_warning (_("unknown line cap style %s\n"), value);
+    } else if (g_str_equal (name, "stroke-opacity")) {
+        state->stroke_opacity = rsvg_css_parse_opacity (value);
         state->has_stroke_opacity = TRUE;
-    } else if (rsvg_css_param_match (str, "stroke-linejoin")) {
+    } else if (g_str_equal (name, "stroke-linejoin")) {
         state->has_join = TRUE;
-        if (!strcmp (str + arg_off, "miter"))
-            state->join = RSVG_PATH_STROKE_JOIN_MITER;
-        else if (!strcmp (str + arg_off, "round"))
-            state->join = RSVG_PATH_STROKE_JOIN_ROUND;
-        else if (!strcmp (str + arg_off, "bevel"))
-            state->join = RSVG_PATH_STROKE_JOIN_BEVEL;
+        if (g_str_equal (value, "miter"))
+            state->join = CAIRO_LINE_JOIN_MITER;
+        else if (g_str_equal (value, "round"))
+            state->join = CAIRO_LINE_JOIN_ROUND;
+        else if (g_str_equal (value, "bevel"))
+            state->join = CAIRO_LINE_JOIN_BEVEL;
         else
-            g_warning (_("unknown line join style %s\n"), str + arg_off);
-    } else if (rsvg_css_param_match (str, "font-size")) {
-        state->font_size = _rsvg_css_parse_length (str + arg_off);
+            g_warning (_("unknown line join style %s\n"), value);
+    } else if (g_str_equal (name, "font-size")) {
+        state->font_size = _rsvg_css_parse_length (value);
         state->has_font_size = TRUE;
-    } else if (rsvg_css_param_match (str, "font-family")) {
-        char *save = g_strdup (rsvg_css_parse_font_family (str + arg_off, &state->has_font_family));
+    } else if (g_str_equal (name, "font-family")) {
+        char *save = g_strdup (rsvg_css_parse_font_family (value, &state->has_font_family));
         g_free (state->font_family);
         state->font_family = save;
-    } else if (rsvg_css_param_match (str, "xml:lang")) {
-        char *save = g_strdup (str + arg_off);
+    } else if (g_str_equal (name, "xml:lang")) {
+        char *save = g_strdup (value);
         g_free (state->lang);
         state->lang = save;
         state->has_lang = TRUE;
-    } else if (rsvg_css_param_match (str, "font-style")) {
-        state->font_style = rsvg_css_parse_font_style (str + arg_off, &state->has_font_style);
-    } else if (rsvg_css_param_match (str, "font-variant")) {
-        state->font_variant = rsvg_css_parse_font_variant (str + arg_off, &state->has_font_variant);
-    } else if (rsvg_css_param_match (str, "font-weight")) {
-        state->font_weight = rsvg_css_parse_font_weight (str + arg_off, &state->has_font_weight);
-    } else if (rsvg_css_param_match (str, "font-stretch")) {
-        state->font_stretch = rsvg_css_parse_font_stretch (str + arg_off, &state->has_font_stretch);
-    } else if (rsvg_css_param_match (str, "text-decoration")) {
-        if (!strcmp (str + arg_off, "inherit")) {
+    } else if (g_str_equal (name, "font-style")) {
+        state->font_style = rsvg_css_parse_font_style (value, &state->has_font_style);
+    } else if (g_str_equal (name, "font-variant")) {
+        state->font_variant = rsvg_css_parse_font_variant (value, &state->has_font_variant);
+    } else if (g_str_equal (name, "font-weight")) {
+        state->font_weight = rsvg_css_parse_font_weight (value, &state->has_font_weight);
+    } else if (g_str_equal (name, "font-stretch")) {
+        state->font_stretch = rsvg_css_parse_font_stretch (value, &state->has_font_stretch);
+    } else if (g_str_equal (name, "text-decoration")) {
+        if (g_str_equal (value, "inherit")) {
             state->has_font_decor = FALSE;
             state->font_decor = TEXT_NORMAL;
         } else {
-            if (strstr (str + arg_off, "underline"))
+            if (strstr (value, "underline"))
                 state->font_decor |= TEXT_UNDERLINE;
-            if (strstr (str + arg_off, "overline"))
+            if (strstr (value, "overline"))
                 state->font_decor |= TEXT_OVERLINE;
-            if (strstr (str + arg_off, "strike") || strstr (str + arg_off, "line-through"))     /* strike though or line-through */
+            if (strstr (value, "strike") || strstr (value, "line-through"))     /* strike though or line-through */
                 state->font_decor |= TEXT_STRIKE;
             state->has_font_decor = TRUE;
         }
-    } else if (rsvg_css_param_match (str, "direction")) {
+    } else if (g_str_equal (name, "direction")) {
         state->has_text_dir = TRUE;
-        if (!strcmp (str + arg_off, "inherit")) {
+        if (g_str_equal (value, "inherit")) {
             state->text_dir = PANGO_DIRECTION_LTR;
             state->has_text_dir = FALSE;
-        } else if (!strcmp (str + arg_off, "rtl"))
+        } else if (g_str_equal (value, "rtl"))
             state->text_dir = PANGO_DIRECTION_RTL;
         else                    /* ltr */
             state->text_dir = PANGO_DIRECTION_LTR;
-    } else if (rsvg_css_param_match (str, "unicode-bidi")) {
+    } else if (g_str_equal (name, "unicode-bidi")) {
         state->has_unicode_bidi = TRUE;
-        if (!strcmp (str + arg_off, "inherit")) {
-            state->unicode_bidi = PANGO_DIRECTION_LTR;
+        if (g_str_equal (value, "inherit")) {
+            state->unicode_bidi = UNICODE_BIDI_NORMAL;
             state->has_unicode_bidi = FALSE;
-        } else if (!strcmp (str + arg_off, "embed"))
+        } else if (g_str_equal (value, "embed"))
             state->unicode_bidi = UNICODE_BIDI_EMBED;
-        else if (!strcmp (str + arg_off, "bidi-override"))
+        else if (g_str_equal (value, "bidi-override"))
             state->unicode_bidi = UNICODE_BIDI_OVERRIDE;
         else                    /* normal */
             state->unicode_bidi = UNICODE_BIDI_NORMAL;
-    } else if (rsvg_css_param_match (str, "writing-mode")) {
+    } else if (g_str_equal (name, "writing-mode")) {
         /* TODO: these aren't quite right... */
 
         state->has_text_dir = TRUE;
-        if (!strcmp (str + arg_off, "inherit")) {
+        state->has_text_gravity = TRUE;
+        if (g_str_equal (value, "inherit")) {
             state->text_dir = PANGO_DIRECTION_LTR;
             state->has_text_dir = FALSE;
-        } else if (!strcmp (str + arg_off, "lr-tb") || !strcmp (str + arg_off, "tb"))
-            state->text_dir = PANGO_DIRECTION_TTB_LTR;
-        else if (!strcmp (str + arg_off, "rl"))
+            state->text_gravity = PANGO_GRAVITY_SOUTH;
+            state->has_text_gravity = FALSE;
+        } else if (g_str_equal (value, "lr-tb") || g_str_equal (value, "lr")) {
+            state->text_dir = PANGO_DIRECTION_LTR;
+            state->text_gravity = PANGO_GRAVITY_SOUTH;
+        } else if (g_str_equal (value, "rl-tb") || g_str_equal (value, "rl")) {
             state->text_dir = PANGO_DIRECTION_RTL;
-        else if (!strcmp (str + arg_off, "tb-rl") || !strcmp (str + arg_off, "rl-tb"))
-            state->text_dir = PANGO_DIRECTION_TTB_RTL;
-        else
+            state->text_gravity = PANGO_GRAVITY_SOUTH;
+        } else if (g_str_equal (value, "tb-rl") || g_str_equal (value, "tb")) {
             state->text_dir = PANGO_DIRECTION_LTR;
-    } else if (rsvg_css_param_match (str, "text-anchor")) {
+            state->text_gravity = PANGO_GRAVITY_EAST;
+        }
+    } else if (g_str_equal (name, "text-anchor")) {
         state->has_text_anchor = TRUE;
-        if (!strcmp (str + arg_off, "inherit")) {
+        if (g_str_equal (value, "inherit")) {
             state->text_anchor = TEXT_ANCHOR_START;
             state->has_text_anchor = FALSE;
         } else {
-            if (strstr (str + arg_off, "start"))
+            if (strstr (value, "start"))
                 state->text_anchor = TEXT_ANCHOR_START;
-            else if (strstr (str + arg_off, "middle"))
+            else if (strstr (value, "middle"))
                 state->text_anchor = TEXT_ANCHOR_MIDDLE;
-            else if (strstr (str + arg_off, "end"))
+            else if (strstr (value, "end"))
                 state->text_anchor = TEXT_ANCHOR_END;
         }
-    } else if (rsvg_css_param_match (str, "letter-spacing")) {
+    } else if (g_str_equal (name, "letter-spacing")) {
 	state->has_letter_spacing = TRUE;
-	state->letter_spacing = _rsvg_css_parse_length (str + arg_off);
-    } else if (rsvg_css_param_match (str, "stop-color")) {
-        if (strcmp (str + arg_off, "inherit")) {
-            state->stop_color = rsvg_css_parse_color (str + arg_off, &state->has_stop_color);
+	state->letter_spacing = _rsvg_css_parse_length (value);
+    } else if (g_str_equal (name, "stop-color")) {
+        if (!g_str_equal (value, "inherit")) {
+            state->stop_color = rsvg_css_parse_color (value, &state->has_stop_color);
         }
-    } else if (rsvg_css_param_match (str, "stop-opacity")) {
-        if (strcmp (str + arg_off, "inherit")) {
+    } else if (g_str_equal (name, "stop-opacity")) {
+        if (!g_str_equal (value, "inherit")) {
             state->has_stop_opacity = TRUE;
-            state->stop_opacity = rsvg_css_parse_opacity (str + arg_off);
+            state->stop_opacity = rsvg_css_parse_opacity (value);
         }
-    } else if (rsvg_css_param_match (str, "marker-start")) {
-        state->startMarker = rsvg_marker_parse (ctx->priv->defs, str + arg_off);
+    } else if (g_str_equal (name, "marker-start")) {
+        g_free (state->startMarker);
+        state->startMarker = rsvg_get_url_string (value);
         state->has_startMarker = TRUE;
-    } else if (rsvg_css_param_match (str, "marker-mid")) {
-        state->middleMarker = rsvg_marker_parse (ctx->priv->defs, str + arg_off);
+    } else if (g_str_equal (name, "marker-mid")) {
+        g_free (state->middleMarker);
+        state->middleMarker = rsvg_get_url_string (value);
         state->has_middleMarker = TRUE;
-    } else if (rsvg_css_param_match (str, "marker-end")) {
-        state->endMarker = rsvg_marker_parse (ctx->priv->defs, str + arg_off);
+    } else if (g_str_equal (name, "marker-end")) {
+        g_free (state->endMarker);
+        state->endMarker = rsvg_get_url_string (value);
         state->has_endMarker = TRUE;
-    } else if (rsvg_css_param_match (str, "stroke-miterlimit")) {
+    } else if (g_str_equal (name, "stroke-miterlimit")) {
         state->has_miter_limit = TRUE;
-        state->miter_limit = g_ascii_strtod (str + arg_off, NULL);
-    } else if (rsvg_css_param_match (str, "stroke-dashoffset")) {
+        state->miter_limit = g_ascii_strtod (value, NULL);
+    } else if (g_str_equal (name, "stroke-dashoffset")) {
         state->has_dashoffset = TRUE;
-        state->dash.offset = _rsvg_css_parse_length (str + arg_off);
+        state->dash.offset = _rsvg_css_parse_length (value);
         if (state->dash.offset.length < 0.)
             state->dash.offset.length = 0.;
-	} else if (rsvg_css_param_match (str, "shape-rendering")) {
-		state->has_shape_rendering_type = TRUE;
-
-        if (!strcmp (str + arg_off, "auto") || !strcmp (str + arg_off, "default"))
-			state->shape_rendering_type = SHAPE_RENDERING_AUTO;
-        else if (!strcmp (str + arg_off, "optimizeSpeed"))
-			state->shape_rendering_type = SHAPE_RENDERING_OPTIMIZE_SPEED;
-        else if (!strcmp (str + arg_off, "crispEdges"))
-			state->shape_rendering_type = SHAPE_RENDERING_CRISP_EDGES;
-        else if (!strcmp (str + arg_off, "geometricPrecision"))
-			state->shape_rendering_type = SHAPE_RENDERING_GEOMETRIC_PRECISION;
-
-	} else if (rsvg_css_param_match (str, "text-rendering")) {
-		state->has_text_rendering_type = TRUE;
-
-        if (!strcmp (str + arg_off, "auto") || !strcmp (str + arg_off, "default"))
-			state->text_rendering_type = TEXT_RENDERING_AUTO;
-        else if (!strcmp (str + arg_off, "optimizeSpeed"))
-			state->text_rendering_type = TEXT_RENDERING_OPTIMIZE_SPEED;
-        else if (!strcmp (str + arg_off, "optimizeLegibility"))
-			state->text_rendering_type = TEXT_RENDERING_OPTIMIZE_LEGIBILITY;
-        else if (!strcmp (str + arg_off, "geometricPrecision"))
-			state->text_rendering_type = TEXT_RENDERING_GEOMETRIC_PRECISION;
-
-    } else if (rsvg_css_param_match (str, "stroke-dasharray")) {
+    } else if (g_str_equal (name, "shape-rendering")) {
+        state->has_shape_rendering_type = TRUE;
+
+        if (g_str_equal (value, "auto") || g_str_equal (value, "default"))
+            state->shape_rendering_type = SHAPE_RENDERING_AUTO;
+        else if (g_str_equal (value, "optimizeSpeed"))
+            state->shape_rendering_type = SHAPE_RENDERING_OPTIMIZE_SPEED;
+        else if (g_str_equal (value, "crispEdges"))
+            state->shape_rendering_type = SHAPE_RENDERING_CRISP_EDGES;
+        else if (g_str_equal (value, "geometricPrecision"))
+            state->shape_rendering_type = SHAPE_RENDERING_GEOMETRIC_PRECISION;
+
+    } else if (g_str_equal (name, "text-rendering")) {
+        state->has_text_rendering_type = TRUE;
+
+        if (g_str_equal (value, "auto") || g_str_equal (value, "default"))
+            state->text_rendering_type = TEXT_RENDERING_AUTO;
+        else if (g_str_equal (value, "optimizeSpeed"))
+            state->text_rendering_type = TEXT_RENDERING_OPTIMIZE_SPEED;
+        else if (g_str_equal (value, "optimizeLegibility"))
+            state->text_rendering_type = TEXT_RENDERING_OPTIMIZE_LEGIBILITY;
+        else if (g_str_equal (value, "geometricPrecision"))
+            state->text_rendering_type = TEXT_RENDERING_GEOMETRIC_PRECISION;
+
+    } else if (g_str_equal (name, "stroke-dasharray")) {
         state->has_dash = TRUE;
-        if (!strcmp (str + arg_off, "none")) {
+        if (g_str_equal (value, "none")) {
             if (state->dash.n_dash != 0) {
                 /* free any cloned dash data */
                 g_free (state->dash.dash);
+                state->dash.dash = NULL;
                 state->dash.n_dash = 0;
             }
         } else {
-            gchar **dashes = g_strsplit (str + arg_off, ",", -1);
+            gchar **dashes = g_strsplit (value, ",", -1);
             if (NULL != dashes) {
                 gint n_dashes, i;
                 gboolean is_even = FALSE;
@@ -736,6 +841,7 @@ rsvg_parse_style_arg (RsvgHandle * ctx, RsvgState * state, const char *str)
                    be ignored */
                 if (total == 0) {
                     g_free (state->dash.dash);
+                    state->dash.dash = NULL;
                     state->dash.n_dash = 0;
                 }
             }
@@ -743,14 +849,6 @@ rsvg_parse_style_arg (RsvgHandle * ctx, RsvgState * state, const char *str)
     }
 }
 
-void
-rsvg_parse_style_pair (RsvgHandle * ctx, RsvgState * state, const char *key, const char *val)
-{
-    gchar *str = g_strdup_printf ("%s:%s", key, val);
-    rsvg_parse_style_arg (ctx, state, str);
-    g_free (str);
-}
-
 static void
 rsvg_lookup_parse_style_pair (RsvgHandle * ctx, RsvgState * state,
                               const char *key, RsvgPropertyBag * atts)
@@ -758,14 +856,14 @@ rsvg_lookup_parse_style_pair (RsvgHandle * ctx, RsvgState * state,
     const char *value;
 
     if ((value = rsvg_property_bag_lookup (atts, key)) != NULL)
-        rsvg_parse_style_pair (ctx, state, key, value);
+        rsvg_parse_style_pair (ctx, state, key, value, FALSE);
 }
 
 /* take a pair of the form (fill="#ff00ff") and parse it as a style */
 void
 rsvg_parse_style_pairs (RsvgHandle * ctx, RsvgState * state, RsvgPropertyBag * atts)
 {
-    rsvg_lookup_parse_style_pair (ctx, state, "a:adobe-blending-mode", atts);
+    rsvg_lookup_parse_style_pair (ctx, state, "baseline-shift", atts);
     rsvg_lookup_parse_style_pair (ctx, state, "clip-path", atts);
     rsvg_lookup_parse_style_pair (ctx, state, "clip-rule", atts);
     rsvg_lookup_parse_style_pair (ctx, state, "color", atts);
@@ -791,6 +889,7 @@ rsvg_parse_style_pairs (RsvgHandle * ctx, RsvgState * state, RsvgPropertyBag * a
     rsvg_lookup_parse_style_pair (ctx, state, "marker-start", atts);
     rsvg_lookup_parse_style_pair (ctx, state, "opacity", atts);
     rsvg_lookup_parse_style_pair (ctx, state, "overflow", atts);
+    rsvg_lookup_parse_style_pair (ctx, state, "shape-rendering", atts);
     rsvg_lookup_parse_style_pair (ctx, state, "stop-color", atts);
     rsvg_lookup_parse_style_pair (ctx, state, "stop-opacity", atts);
     rsvg_lookup_parse_style_pair (ctx, state, "stroke", atts);
